# Coverage for Doctrine_Transaction_Oracle

Back to coverage report

1 | <?php
2 | /*
3 | * $Id: Oracle.php 2963 2007-10-21 06:23:59Z Jonathan.Wage $
4 | *
5 | * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
6 | * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
7 | * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
8 | * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
9 | * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
10 | * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
11 | * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
12 | * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
13 | * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
14 | * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
15 | * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
16 | *
17 | * This software consists of voluntary contributions made by many individuals
18 | * and is licensed under the LGPL. For more information, see
19 | * <http://www.phpdoctrine.org>.
20 | */
21 | Doctrine::autoload('Doctrine_Transaction');
22 | /**
23 | *
24 | * @author Konsta Vesterinen <kvesteri@cc.hut.fi>
25 | * @author Lukas Smith <smith@pooteeweet.org> (PEAR MDB2 library)
26 | * @license http://www.opensource.org/licenses/lgpl-license.php LGPL
27 | * @package Doctrine
28 | * @subpackage Transaction
29 | * @link www.phpdoctrine.org
30 | * @since 1.0
31 | * @version $Revision: 2963 $
32 | */
33 | class Doctrine_Transaction_Oracle extends Doctrine_Transaction
34 | {
35 | /**
36 | * createSavepoint
37 | * creates a new savepoint
38 | *
39 | * @param string $savepoint name of a savepoint to set
40 | * @return void
41 | */
42 | protected function createSavePoint($savepoint)
43 | {
44 | $query = 'SAVEPOINT ' . $savepoint;
45 |
46 | return $this->conn->execute($query);
47 | }
48 |
49 | /**
50 | * releaseSavePoint
51 | * releases given savepoint
52 | *
53 | * @param string $savepoint name of a savepoint to release
54 | * @return void
55 | */
56 | protected function releaseSavePoint($savepoint)
57 | {
58 | // oracle doesn't support manual releasing of savepoints
59 | return true;
60 | }
61 |
62 | /**
63 | * rollbackSavePoint
64 | * releases given savepoint
65 | *
66 | * @param string $savepoint name of a savepoint to rollback to
67 | * @return void
68 | */
69 | protected function rollbackSavePoint($savepoint)
70 | {
71 | $query = 'ROLLBACK TO SAVEPOINT ' . $savepoint;
72 |
73 | return $this->conn->execute($query);
74 | }
75 |
76 | /**
77 | * Set the transacton isolation level.
78 | *
79 | * @param string standard isolation level
80 | * READ UNCOMMITTED (allows dirty reads)
81 | * READ COMMITTED (prevents dirty reads)
82 | * REPEATABLE READ (prevents nonrepeatable reads)
83 | * SERIALIZABLE (prevents phantom reads)
84 | * @throws PDOException if something fails at the PDO level
85 | * @throws Doctrine_Transaction_Exception if using unknown isolation level
86 | * @return void
87 | */
88 | public function setIsolation($isolation)
89 | {
90 | switch ($isolation) {
91 | case 'READ UNCOMMITTED':
92 | $isolation = 'READ COMMITTED';
93 | break;
94 | case 'READ COMMITTED':
95 | case 'REPEATABLE READ':
96 | case 'SERIALIZABLE':
97 | $isolation = 'SERIALIZABLE';
98 | break;
99 | default:
100 | throw new Doctrine_Transaction_Exception('Isolation level ' . $isolation . ' is not supported.');
101 | }
102 |
103 | $query = 'ALTER SESSION ISOLATION LEVEL ' . $isolation;
104 | return $this->conn->execute($query);
105 | }
106 | }